#ifndef __anyExample_hh__
#define __anyExample_hh__

#include <omniORB2/CORBA.h>

struct testStruct {
  CORBA::Long l;
  CORBA::Short s;
  
  size_t NP_alignedSize(size_t initialoffset) const;
  void operator>>= (NetBufferedStream &) const;
  void operator<<= (NetBufferedStream &);
  void operator>>= (MemBufferedStream &) const;
  void operator<<= (MemBufferedStream &);
};

typedef _CORBA_ConstrType_Fix_Var<testStruct> testStruct_var;

extern const CORBA::TypeCode_ptr _tc_testStruct;

inline void operator<<=(CORBA::Any& _a, const testStruct& _s) {
  MemBufferedStream _0RL_mbuf;
  _tc_testStruct->NP_fillInit(_0RL_mbuf);
  _s >>= _0RL_mbuf;
  _a.NP_replaceData(_tc_testStruct,_0RL_mbuf);
}

inline void operator<<=(CORBA::Any& _a, testStruct* _sp) {
  ::operator<<=(_a,*_sp);
  delete _sp;
}

CORBA::Boolean operator>>=(const CORBA::Any& _a, testStruct*& _sp);

#ifndef __anyExample__
#define __anyExample__
class   anyExample;
typedef anyExample* anyExample_ptr;
typedef anyExample_ptr anyExampleRef;

class anyExample_Helper {
  public:
  static anyExample_ptr _nil();
  static CORBA::Boolean is_nil(anyExample_ptr p);
  static void release(anyExample_ptr p);
  static void duplicate(anyExample_ptr p);
  static size_t NP_alignedSize(anyExample_ptr obj,size_t initialoffset);
  static void marshalObjRef(anyExample_ptr obj,NetBufferedStream &s);
  static anyExample_ptr unmarshalObjRef(NetBufferedStream &s);
  static void marshalObjRef(anyExample_ptr obj,MemBufferedStream &s);
  static anyExample_ptr unmarshalObjRef(MemBufferedStream &s);
};
typedef _CORBA_ObjRef_Var<anyExample,anyExample_Helper> anyExample_var;

#endif
#define anyExample_IntfRepoID "IDL:anyExample:1.0"

class anyExample : public virtual omniObject, public virtual CORBA::Object {
public:

  virtual CORBA::Any * testOp ( const CORBA::Any & mesg ) = 0;
  static anyExample_ptr _duplicate(anyExample_ptr);
  static anyExample_ptr _narrow(CORBA::Object_ptr);
  static anyExample_ptr _nil();

  static inline size_t NP_alignedSize(anyExample_ptr obj,size_t initialoffset) {
    return CORBA::AlignedObjRef(obj,anyExample_IntfRepoID,19,initialoffset);
  }

  static inline void marshalObjRef(anyExample_ptr obj,NetBufferedStream &s) {
    CORBA::MarshalObjRef(obj,anyExample_IntfRepoID,19,s);
  }

  static inline anyExample_ptr unmarshalObjRef(NetBufferedStream &s) {
    CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(anyExample_IntfRepoID,s);
    anyExample_ptr _result = anyExample::_narrow(_obj);
    CORBA::release(_obj);
    return _result;
  }

  static inline void marshalObjRef(anyExample_ptr obj,MemBufferedStream &s) {
    CORBA::MarshalObjRef(obj,anyExample_IntfRepoID,19,s);
  }

  static inline anyExample_ptr unmarshalObjRef(MemBufferedStream &s) {
    CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(anyExample_IntfRepoID,s);
    anyExample_ptr _result = anyExample::_narrow(_obj);
    CORBA::release(_obj);
    return _result;
  }

  static CORBA::Boolean _0RL_is_a(const char *base_repoId);

protected:

  anyExample() {
    if (!is_proxy())
      omniObject::PR_IRRepositoryId(anyExample_IntfRepoID);
    this->PR_setobj(this);
  }
  virtual ~anyExample() {}
  virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

private:

  anyExample(const anyExample&);
  anyExample &operator=(const anyExample&);
};

class _sk_anyExample :  public virtual anyExample {
public:

  _sk_anyExample() {}
  _sk_anyExample(const omniORB::objectKey& k);
  virtual ~_sk_anyExample() {}
  anyExample_ptr _this() { return anyExample::_duplicate(this); }
  void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
  CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
  void _dispose() { _boa()->dispose(this); }
  omniORB::objectKey _key();
  virtual CORBA::Any * testOp ( const CORBA::Any & mesg ) = 0;
  virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

protected:
  virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
    return anyExample::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
  }
private:
  _sk_anyExample (const _sk_anyExample&);
  _sk_anyExample &operator=(const _sk_anyExample&);
};

class _proxy_anyExample :  public virtual anyExample {
public:

  _proxy_anyExample (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
    omniObject(anyExample_IntfRepoID,r,key,keysize,profiles,release) {
      omni::objectIsReady(this);
  }
  virtual ~_proxy_anyExample() {}
  virtual CORBA::Any * testOp ( const CORBA::Any & mesg );

protected:

  _proxy_anyExample () {}

  virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
    return anyExample::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
  }
private:

  _proxy_anyExample (const _proxy_anyExample&);
  _proxy_anyExample &operator=(const _proxy_anyExample&);
};

class _nil_anyExample : public virtual anyExample {
public:
  _nil_anyExample() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
  virtual ~_nil_anyExample() {}
  CORBA::Any * testOp ( const CORBA::Any & mesg ){
    throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
    // never reach here! Dummy return to keep some compilers happy.
    CORBA::Any * _0RL_result = 0;
    return _0RL_result;
#endif
  }

protected:
  virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
    return anyExample::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
  }
};

class anyExample_proxyObjectFactory : public proxyObjectFactory {
public:
  anyExample_proxyObjectFactory () {}
  virtual ~anyExample_proxyObjectFactory () {}
  virtual const char *irRepoId() const;
  virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
  virtual CORBA::Boolean is_a(const char *base_repoId) const;
  static anyExample_ptr _nil() {
    if (!__nil_anyExample) {
      __nil_anyExample = new _nil_anyExample;
    }
    return __nil_anyExample;
  }
private:
  static anyExample_ptr __nil_anyExample;
};

extern const CORBA::TypeCode_ptr _tc_anyExample;

inline void operator<<=(CORBA::Any& _a, anyExample_ptr _s) {
  MemBufferedStream _0RL_mbuf;
  _tc_anyExample->NP_fillInit(_0RL_mbuf);
  anyExample::marshalObjRef(_s,_0RL_mbuf);
  _a.NP_replaceData(_tc_anyExample,_0RL_mbuf);
}

inline void operator<<=(CORBA::Any& _a, anyExample_ptr* _sp) {
  ::operator<<=(_a,*_sp);
  CORBA::release(*_sp);
}

CORBA::Boolean operator>>=(const CORBA::Any& _a, anyExample_ptr& _s);

#endif // __anyExample_hh__
