/***********************************************************
        Copyright 1996 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <net/route.h>
#include <netdb.h>
#include <syslog.h>
#include <errno.h>


#include "bootp.h"
#include "bootpd.h"
#include "dhcp.h"
#include "dhcpd.h"
#include "perm.h"
#include "hash.h"



int bind2data(p,buf,len)
struct lastbind *p;
unsigned char *buf;
int len;
{
		int datalen;
		datalen=0;
		buf[datalen++]=p->cliid->length;
		bcopy(p->cliid->data,&buf[datalen], p->cliid->length);
		datalen+=p->cliid->length;

		buf[datalen++]=p->cliidhw->length;
		bcopy(p->cliidhw->data,&buf[datalen], p->cliidhw->length);
		datalen+=p->cliidhw->length;

		bcopy(&p->last_ip,&buf[datalen],4);
		datalen+=4;
		bcopy(&p->replys,&buf[datalen],4);
		datalen+=4;
		bcopy(&p->last_touch,&buf[datalen],4);
		datalen+=4;
		bcopy(&p->expire,&buf[datalen],4);
		datalen+=4;
		buf[datalen++]=p->code;

		if(p->vend){
			buf[datalen++]=p->vend->length;
			bcopy(p->vend->data,&buf[datalen], p->vend->length);
			datalen+=p->vend->length;
		} else
			buf[datalen++]=0;

		if(p->user){
			buf[datalen++]=p->user->length;
			bcopy(p->user->data,&buf[datalen], p->user->length);
			datalen+=p->user->length;
		} else
			buf[datalen++]=0;

		return datalen;
}
	

struct lastbind *data2bind(data,len)
hash_datum *data;
int len;
{
 struct lastbind *p;
 char *cp;

 if(!data)
	return NULL;
 cp=data;

 /* walk data to check it */
 len-=1+*cp;
 if(len<0)
	return NULL;
 cp+=1+*cp;

 len-=1+*cp;
 if(len<0)
	return NULL;
 cp+=1+*cp;

 len-=17;
 if(len<0)
	return NULL;
 cp+=17;

 len-=1+*cp;
 if(len<0)
	return NULL;
 cp+=1+*cp;

 len-=1+*cp;
 if(len<0)
	return NULL;

 cp=data;
 p=(struct lastbind*)malloc(sizeof(struct lastbind));
 bzero(p,sizeof(struct lastbind));

 p->cliid=(struct shared_bindata*)malloc(sizeof(struct shared_bindata)+*cp-1);
 p->cliid->linkcount=1;
 p->cliid->length=*cp;
 bcopy(++cp,p->cliid->data,p->cliid->length);
 cp+=p->cliid->length;
 p->clhashcode=hash_HashFunction(p->cliid->data,p->cliid->length);

 p->cliidhw=(struct shared_bindata*)malloc(sizeof(struct shared_bindata)+*cp-1);
 p->cliidhw->linkcount=1;
 p->cliidhw->length=*cp;
 bcopy(++cp,p->cliidhw->data,p->cliidhw->length);
 cp+=p->cliidhw->length;

 bcopy(cp,&p->last_ip,4);
 cp+=4;
 bcopy(cp,&p->replys,4);
 cp+=4;
 bcopy(cp,&p->last_touch,4);
 cp+=4;
 bcopy(cp,&p->expire,4);
 cp+=4;
 p->code=*cp++;

   
 if(*cp){
     p->vend=(struct shared_bindata*)malloc(sizeof(struct shared_bindata)+*cp-1)
;
     p->vend->length=*cp;
     bcopy(++cp,p->vend->data,p->vend->length);
     p->vend->linkcount=1;
     cp+=p->vend->length;
 } else
     cp++;

 if(*cp){
     p->user=(struct shared_bindata*)malloc(sizeof(struct shared_bindata)+*cp-1
);
     p->user->length=*cp;
     bcopy(++cp,p->user->data,p->user->length);
     p->user->linkcount=1;
     cp+=p->user->length;
 }
 free(data);

 return p;
}

