/* 
 * Copyright 1993, 1994, 1995 Liverpool University Computer Science Department
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided 
 * that the above copyright notice appear in all copies and that both that 
 * copyright notice and this permission notice appear in supporting 
 * documentation, and that the name of L.U.C.S. not be used in advertising
 * or publicity pertaining to distribution of the software without specific, 
 * written prior permission. L.U.C.S. makes no representations about the 
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * FILE NAME:   wwwtar_config.h
 * CREATED:     Tue May 9 1995
 * AUTHOR:      Rik Turnbull (rik@csc.liv.ac.uk)
 * DESCRIPTION: Configuration file for wwwtar.
 *
 */

#ifndef	WWWTAR_WWWTAR_CONFIG_H
#define	WWWTAR_WWWTAR_CONFIG_H

/* Where wwwtar will be installed. This is so that wwwtar can reference itself
   via a URL. eg HREF=/htbin/wwwtar?tarfile
*/
#define	WWWTAR_CGIBIN		"cgi-bin"

/* This is a chunk of HTML to print at the top of the document. You could use
   it to put in logo.
*/
#define	WWWTAR_DOC_HEADER	"<IMG SRC=http://www.csc.liv.ac.uk/logo.gif>\n<P>\n"

/* This is where all the tar files are stored. URLs for wwwtar will have this
   stripped off the beginning. If you want to make all the tar files on
   your web server available, then this will be the document root.
*/
#define	WWWTAR_ROOT		"/users/www/docs"

/* This is the footer that is placed at the bottom of all HTML documents.
   You're not obliged to keep this as a pointer to my wwwtar page, but
   I'd prefer it.
*/
#define	WWWTAR_FOOTER		"<HR>\n</PRE>\n<I>Document generated by \
				<A HREF=http://www.csc.liv.ac.uk/users/rik/wwwtar/> WWWTar</A> 1.0.</I>\n"

/* The maximum size of a tar file viewable across the web. I've set this to
   1MB to prevent processing of files which are too large.
*/
#define WWWTAR_MAX_FILE_SIZE	1000000

#endif
